 typedef enum {
  Element, Text, Comment, Declaration, Procins, Root
} Nodetype;
 typedef struct _node {
  Nodetype tp;
  unsigned char *name;
  pairlist attribs;
  unsigned char *text;
  struct _node *parent;
  struct _node *sister;
  struct _node *children;
} Node, *Tree;
 Tree create(void);
 Tree get_root(Tree t);
 Boolean get_attrib(Node *e, unsigned char *attname, unsigned char **val);
 void set_attrib(Node *e, unsigned char *name, unsigned char *value);
 Boolean is_known(unsigned char *e);
 Boolean is_pre(unsigned char *e);
 Boolean need_etag(unsigned char *e);
 Boolean is_empty(unsigned char *e);
 Boolean is_mixed(const char *e);
 Boolean break_before(const char *e);
 Boolean break_after(const char *e);
 Tree html_push(Tree t, unsigned char *elem, pairlist attr);
 Tree html_pop(Tree t, unsigned char *elem);
 Tree append_comment(Tree t, unsigned char *comment);
 Tree append_declaration(Tree t, unsigned char *declaration);
 Tree append_procins(Tree t, unsigned char *procins);
 Tree append_text(Tree t, unsigned char *text);
 void dumptree(Tree t);
